using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Authorization;

using DomainResults.Mvc;

using WeatherForecast.Services;

namespace WeatherForecast.Controllers;

/// <summary>
/// 
/// </summary>
[Authorize(Policy = "")]
[ApiController]
[Route("api/[controller]")]
public class BlogItemsController : ControllerBase {

  private readonly IBlogItemsService _blogItemsService;

  /// <summary>
  /// 
  /// </summary>
  /// <param name="blogItemsService"></param>
  public BlogItemsController(
    IBlogItemsService blogItemsService
    ) {
    _blogItemsService = blogItemsService;
  }

  /// <summary>
  /// 
  /// </summary>
  /// <param name="siteId"></param>
  /// <param name="category"></param>
  /// <param name="searchText"></param>
  /// <param name="currentPage"></param>
  /// <param name="itemsPerPage"></param>
  /// <param name="locale"></param>
  /// <returns></returns>
  [AllowAnonymous]
  [HttpGet("{siteId}")]
  public IActionResult Get([FromRoute] Guid siteId, [FromQuery] Guid? category, [FromQuery] string? searchText, [FromQuery] int? currentPage, [FromQuery] int? itemsPerPage, [FromQuery] string? locale) {
    var result = _blogItemsService.Get(siteId, category, currentPage ?? 1, itemsPerPage ?? 8, locale, searchText);
    return result.ToActionResult();
  }

  /// <summary>
  /// 
  /// </summary>
  /// <param name="siteId"></param>
  /// <returns></returns>
  [Authorize]
  [HttpDelete("{siteId}")]
  public IActionResult Delete([FromRoute] Guid siteId) {
    var result = _blogItemsService.Delete(siteId);
    return result.ToActionResult();
  }
}

